#! /usr/bin/env python
# -*- coding: utf-8 -*-
import nltk
import random
from nltk.tokenize import word_tokenize

def classify(text):
  f = word_feature(all_words, text)
  text_class = classifier.classify(f)
  dist = classifier.prob_classify(f)
  desc = ""
  for label in dist.samples():
      desc += " "+("%s: %f" % (label, dist.prob(label)))
  return text_class, desc.strip()
  
def word_feature(all_words, text):
  z = {}
  for word in all_words:
      z[word] = word in word_tokenize(text)
  return z 

def get_data(filenames, rows = 0):
  labeled_text = []
  for filename in filenames:
      i = 0   
      with open(filename) as f:
         for line in f:
            labeled_text.append((line.strip().decode("utf-8"), filename.split(".")[0]))
            i += 1
            if rows!=0 and i>rows:
               break
  return labeled_text
  
labeled_texts = get_data(["town.txt","human.txt"])

random.shuffle(labeled_texts)
#print labeled_texts
all_words = set(word for passage in labeled_texts for word in word_tokenize(passage[0]))
train_set = [(word_feature(all_words, x[0]), x[1]) for x in labeled_texts[:len(labeled_texts)/2]]
test_set = [(word_feature(all_words, x[0]), x[1]) for x in labeled_texts[len(labeled_texts)/2:]]
#print train_set
classifier = nltk.NaiveBayesClassifier.train(train_set)

print "test set accuracy: "+str(nltk.classify.accuracy(classifier, test_set))
print "train set accuracy: "+str(nltk.classify.accuracy(classifier, train_set))
print classifier.show_most_informative_features(20)

test_sentence = u'Saulmory-et-Villefranche je francouzská obec'
print test_sentence 
print classify(test_sentence)
test_sentence = u'Dune 2000 je vylepšená verze hry Dune II , vydanou společností Virgin/EA pod hlavičkou firmy Westwood Studios .' 
print test_sentence
print classify(test_sentence)
test_sentence = u'William Shakespeare (pokřtěn 26. dubna 1564 - zemřel 23. dubna 1616) byl významný anglický básník a dramatik' 
print test_sentence
print classify(test_sentence)
test_sentence = u'Quintus Curtius Rufus byl historik' 
print test_sentence
print classify(test_sentence)       